openrc/init.d/hostid.in

81 lines
1.3 KiB
Plaintext
Raw Normal View History

#!@SBINDIR@/runscript
2009-05-01 19:41:40 +05:30
# Copyright (c) 2007-2009 Roy Marples <roy@marples.name>
# Released under the 2-clause BSD license.
extra_commands="reset"
2009-04-27 13:21:18 +05:30
: ${hostid_file:=/etc/hostid}
depend()
{
2009-02-11 23:12:14 +05:30
use root
2007-12-07 20:02:57 +05:30
before devd net
keyword -jail -prefix
}
_set()
{
local id=0
if [ -n "$1" ]; then
id=$(echo "$1" | md5)
id="0x${id%????????????????????????}"
fi
2009-04-27 13:21:18 +05:30
ebegin "Setting Host ID: $id"
sysctl -w kern.hostid="$id" >/dev/null
2008-01-11 05:18:53 +05:30
eend $? || return 1
if sysctl -n kern.hostuuid >/dev/null 2>&1; then
[ -n "$1" ] && id=$1
2009-04-27 13:21:18 +05:30
ebegin "Setting Host UUID: $id"
sysctl kern.hostuuid="$id" >/dev/null
2008-01-11 05:18:53 +05:30
eend $? || return 1
fi
}
# First we check to see if there is a system UUID
# If so then we use that and erase the hostid file,
# otherwise we generate a random UUID.
reset()
{
2009-04-27 13:21:18 +05:30
local uuid= x="[0-9a-f]" y="$x$x$x$x"
2008-10-03 23:20:30 +05:30
if type kenv >/dev/null 2>&1; then
uuid=$(kenv smbios.system.uuid 2>/dev/null)
fi
2009-04-27 13:21:18 +05:30
case "$uuid" in
$y$y-$y-$y-$y-$y$y$y);;
*) uuid=;;
esac
2009-04-27 13:21:18 +05:30
if [ -n "$uuid" ]; then
rm -f "$hostid_file"
else
uuid=$(uuidgen)
2009-04-27 13:21:18 +05:30
if [ -z "$uuid" ]; then
eerror "Unable to generate a UUID"
return 1
fi
2009-04-27 13:21:18 +05:30
if ! echo "$uuid" >"$hostid_file"; then
eerror "Failed to store UUID in \`$hostid_file'"
return 1
fi
fi
2009-04-27 13:21:18 +05:30
_set "$uuid"
}
start()
{
2009-04-27 13:21:18 +05:30
if [ -r "$hostid_file" ]; then
_set $(cat "$hostid_file")
else
reset
fi
}
stop()
{
_set
}